(in-package "SLEEPYCAT")

;;; -*- Mode: Lisp; Syntax: ANSI-Common-Lisp; Base: 10 -*-
;;;
;;; controller.lisp -- Lisp interface to a Berkeley DB store
;;; 
;;; Initial version 8/26/2004 by Ben Lee
;;; <blee@common-lisp.net>
;;; 
;;; part of
;;;
;;; Elephant: an object-oriented database for Common Lisp
;;;
;;; Copyright (c) 2004 by Andrew Blumberg and Ben Lee
;;; <ablumberg@common-lisp.net> <blee@common-lisp.net>
;;;
;;; This program is released under the following license
;;; ("GPL").  For differenct licensing terms, contact the
;;; copyright holders.
;;;
;;; This program is free software; you can redistribute it
;;; and/or modify it under the terms of the GNU General
;;; Public License as published by the Free Software
;;; Foundation; either version 2 of the License, or (at
;;; your option) any later version.
;;;
;;; This program is distributed in the hope that it will be
;;; useful, but WITHOUT ANY WARRANTY; without even the
;;; implied warranty of MERCHANTABILITY or FITNESS FOR A
;;; PARTICULAR PURPOSE. See the GNU General Public License
;;; for more details.
;;;
;;; The GNU General Public License can be found in the file
;;; LICENSE which should have been distributed with this
;;; code.  It can also be found at
;;;
;;; http://www.opensource.org/licenses/gpl-license.php
;;;
;;; You should have received a copy of the GNU General
;;; Public License along with this program; if not, write
;;; to the Free Software Foundation, Inc., 59 Temple Place,
;;; Suite 330, Boston, MA 02111-1307 USA
;;;


#+cmu
(eval-when (:compile-toplevel)
  (proclaim '(optimize (ext:inhibit-warnings 3))))

(eval-when (:compile-toplevel :load-toplevel)
  ;; UFFI
  ;;(asdf:operate 'asdf:load-op :uffi)

  ;; DSO loading - Edit these for your system!

  ;; Under linux you may need to load some kind of pthread
  ;; library.  I can't figure out which is the right one.
  ;; This one worked for me.  There are known issues with
  ;; Red Hat and Berkeley DB, search google.
  #+linux
  (unless 
      (uffi:load-foreign-library "/lib/tls/libpthread.so.0" :module "pthread")
    (error "Couldn't load libpthread!"))

    (unless
        (uffi:load-foreign-library 
         (if (find-package 'asdf)
 	   (merge-pathnames 
 	    #p"libmemutil.so"
 	    (asdf:component-pathname (asdf:find-system 'elephant)))
  	   "/usr/local/share/common-lisp/elephant-0.2/libmemutil.so")
         :module "libmemutil")
      (error "Couldn't load libmemutil.so!"))


;; This code has now been moved to the small, asdf-loadable system
;; called "bdb-enable".  Do : (asdf:operate 'asdf:load-op :ele-bdb)
;; to enable the use of BerkeleyDB as a back store.
  (unless
      (uffi:load-foreign-library 
       ;; Sleepycat: this works on linux
       #+linux
;;       "/db/ben/lisp/db43/lib/libdb.so" 
       "/usr/local/BerkeleyDB.4.3/lib/libdb-4.3.so"
       ;; this works on FreeBSD
       #+(and (or bsd freebsd) (not darwin))
       "/usr/local/lib/db43/libdb.so" 
       #+darwin
       "/usr/local/BerkeleyDB.4.3/lib/libdb.dylib" 
       :module "sleepycat")
    (error "Couldn't load libdb (Sleepycat)!"))

   ;; Libsleepycat.so: edit this
   (unless
       (uffi:load-foreign-library 
        (if (find-package 'asdf)
 	   (merge-pathnames 
 	    #p"libsleepycat.so"
 	    (asdf:component-pathname (asdf:find-system 'elephant)))
 	   "/usr/local/share/common-lisp/elephant-0.2/libsleepycat.so")
        :module "libsleepycat")
     (error "Couldn't load libsleepycat!"))

)
